# puppet_dev_env puppet module

[![Puppet Forge](http://img.shields.io/puppetforge/v/landcareresearch/puppet-dev-env.svg)](https://forge.puppetlabs.com/landcaresearch/puppet-dev-env)
[![Bitbucket Build Status](http://build.landcareresearch.co.nz/app/rest/builds/buildType%3A%28id%3ALinuxAdmin_PuppetPuppetDevEnv_PuppetPuppetDevEnv%29/statusIcon)](http://build.landcareresearch.co.nz/viewType.html?buildTypeId=LinuxAdmin_PuppetPuppetDevEnv_PuppetPuppetDevEnv&guest=1)

## About

Installs tools and configuration to support a puppet developer.

## Requirements

* Puppet installed locally.

## Usage

###Classes and Defined Types

####Class: `puppet_dev_env`

Sets up various vim plugins and scripts.

**Parameters within `puppet_dev_env`:**

#####`user`
The username to install the development environment
Note, the user must already exist

#####`user_home_dir`
The directory of the user.  
Default: '/home/${user}'

### Beginning with puppet_dev_env

The basic use case is as below:

```
	class { 'puppet_dev_env' :
  	  user => 'user_name',
	}
```

This sets up VIM configuration for the user specified.
This assumes the user's home directory is /home/<username>.
It also installs the puppet-test script in /usr/local/bin.

If the user has a different home path, than use the following:

```
	class { 'puppet_dev_env' :
  	  user 			=> 'user_name',
  	  user_home_dir => 'path',
	}
```

## Features
Install pathogen to easily install and manage vim plugins.
Installs the following plugins by default: nerdtree, nerdtreetabs, tabular, 
vim-puppet, numbers.
Also installs puppet-lint.

## Commands
#### puppet-test
* **Usage**: puppet-test [filename].pp
* **Function**: Runs puppet parser and puppet lint on the file

#### graph-dot
* **Usage**: graph-dot [input file] [output file]
* **Function**: converts the dot (generated by --graph via puppet apply) to a ps file.

### VIM Shortcuts
```
    F3 - NumbersToggle
    F4 - NumbersOnOff
    F5 - NERDTreeToggle
```

## License

GPL version 3

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, [see](http://www.gnu.org/licenses/).
